function edgeLength = computeEdgeLengthVrep(vrep, dirMatrix, zerotol)
% compute edge lengths of a V-polytope
%
% Syntax: edgeLength = computeEdgeLengthVrep(vrep, dirMatrix)
%
% This function calculates a vector of edge lengths for all directions
%   in dirMatrix (one direction in each row). The direction specifies a
%   normal vector for the hyperplane to obtain the corresponding support
%   set. The given direction for an edge must be normal to the edge and
%   between the normal vectors of the adjacent facets.
%
% computeEdgeLengthVrep(..., zerotol) allows to set the tolerance for 
%   underlying algorithms (determining flat polytopes; default in
%   elkZerotol).
%
% See also: computeEdgeLengthHrep, computeFacetAreaVrep, computeVolumeVrep,
%   computeProjectionAreaVrep, computeFeretVrep, computeSupportValueVrep

% The elk-library: convex geometry applied to crystallization modeling.
%   Copyright (C) 2012 Alexander Reinhold
%
% This program is free software: you can redistribute it and/or modify it 
%   under the terms of the GNU General Public License as published by the 
%   Free Software Foundation, either version 3 of the License, or (at your 
%   option) any later version.
%
% This program is distributed in the hope that it will be useful, but 
%   WITHOUT ANY WARRANTY; without even the implied warranty of 
%   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU 
%   General Public License for more details.
%
% You should have received a copy of the GNU General Public License along 
%   with this program.  If not, see <http://www.gnu.org/licenses/>.

%% Input handling
% default zerotol
if ~exist('zerotol', 'var')
    zerotol = elkZerotol;
end

%% do for each edge
edgeLength = zeros(1, size(dirMatrix, 1));
for iEdge = 1:size(dirMatrix, 1)
    % Get support set in direction
    supportVrep = computeSupportSetVrep(vrep, dirMatrix(iEdge, :), zerotol);
    
    % Calculate volume of support set (1-D Volume)
    if size(supportVrep.V, 2) == 1
        edgeLength(iEdge) = computeVolumeVrep(supportVrep, zerotol);
    elseif size(supportVrep.V, 2) == 0
        edgeLength(iEdge) = 0;
    else
        % this case is also taken as 0, because otherwise the vectors that
        %   describe the edges must be artificially distorted so that they 
        %   do not match a facet in a different unified partition.
        edgeLength(iEdge) = 0;
    end
end